///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK JobManagerDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HMENU SystemMenu   = NULL;
    static HMENU DialogMenu   = NULL;

    //--------------------------------------------------------------------------

    if(xMessage == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        JobManagerDialog_hWnd = xHandle;

        SystemMenu = GetSystemMenu(JobManagerDialog_hWnd, FALSE);
        AppendMenu(SystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(SystemMenu, MF_STRING, 1000, "About");
        AppendMenu(SystemMenu, MF_STRING, 1001, "Version");
        AppendMenu(SystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(SystemMenu, MF_STRING, 1002, "www.NetWorkDLS.com");

        SendMessage(JobManagerDialog_hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)TitleCaption);
        SendMessage(JobManagerDialog_hWnd, WM_SETICON, TRUE, (LPARAM)LoadIcon(MainInstance, MAKEINTRESOURCE(DialogIcon)) );

        StatusListBox_hWnd = GetDlgItem(JobManagerDialog_hWnd, 1000);

        DialogMenu = LoadMenu(MainInstance, MAKEINTRESOURCE(JobManagerMenu));
        SetMenu(JobManagerDialog_hWnd, DialogMenu);

        if(AllOnHold == TRUE)
            ModifyMenu(DialogMenu, 30003, MF_BYCOMMAND+MF_UNCHECKED, 30003, "Schedule On Hold");

        if(AllOnHold == FALSE)
            ModifyMenu(DialogMenu, 30003, MF_BYCOMMAND+MF_CHECKED, 30003, "Schedule Ready");

        LoadJobHistory(StatusListBox_hWnd);

        CenterWindow(JobManagerDialog_hWnd);

        StartupComplete = TRUE;

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_SIZE ) // Received A Message
    {
        int nWidth = LOWORD(lParam);
        int nHeight = HIWORD(lParam);
        MoveWindow(StatusListBox_hWnd, 0, 0, nWidth, nHeight, TRUE);
        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_COMMAND) // Received A Message
    {
        if(wParam==10001) //- Options (Dialog Menu Command)
        {
            if( IsWinNT() )
            {
                DialogBox(MainInstance, MAKEINTRESOURCE(wNTOptions), JobManagerDialog_hWnd, wNTOptionsDialog);
            }
            else{
                DialogBox(MainInstance, MAKEINTRESOURCE(w9xOptions), JobManagerDialog_hWnd, w9xOptionsDialog);
            }

            return 0;
        }

        if(wParam==10002) //- Job log (Dialog Menu Command)
        {
            DialogBox(MainInstance, MAKEINTRESOURCE(ViewLog), JobManagerDialog_hWnd, ViewLogDialog);
            return 0;
        }

        if(wParam==10003) //- Close (Dialog Menu Command)
        {
            EndDialog(JobManagerDialog_hWnd,0);
            return 0;
        }

        if(wParam==20001) //- Manual Backup (Dialog Menu Command)
        {
        	DialogBox(MainInstance, MAKEINTRESOURCE(ManBackup), JobManagerDialog_hWnd, ManBackupDialog);
            return 0;
        }
        if(wParam==20002) //- Manual Restore (Dialog Menu Command)
        {
        	DialogBox(MainInstance, MAKEINTRESOURCE(ManRestore), JobManagerDialog_hWnd, ManRestoreDialog);
            return 0;
        }

        if(wParam==30001) //- Maintain Schedule (Dialog Menu Command)
        {
            if(CurrentlyRunning == TRUE)
            {
                MessageBox(JobManagerDialog_hWnd, "Please wait untill the current process has completed.", TitleCaption, MB_TASKMODAL);
                return 0;
            }

            if(AllOnHold == TRUE)
            {
                DialogBox(MainInstance, MAKEINTRESOURCE(MaintainSchedule), JobManagerDialog_hWnd, ScheduleDialog);
            }
            else{
                AllOnHold = TRUE;
                DialogBox(MainInstance, MAKEINTRESOURCE(MaintainSchedule), JobManagerDialog_hWnd, ScheduleDialog);
                AllOnHold = FALSE;
            }
            return 0;
        }

        if(wParam==30002) //- View Schedule (Dialog Menu Command)
        {
            DialogBox(MainInstance, MAKEINTRESOURCE(ViewSchedule), JobManagerDialog_hWnd, ViewScheduleDialog);

            return 0;
        }

        if(wParam==30003) //- On Hold (Dialog Menu Command)
        {
            if(AllOnHold == TRUE)
            {
                ModifyMenu(DialogMenu, 30003, MF_BYCOMMAND+MF_CHECKED, 30003, "Schedule Ready");
                AllOnHold = FALSE;
                return 0;
            }

            if(AllOnHold == FALSE)
            {
                ModifyMenu(DialogMenu, 30003, MF_BYCOMMAND+MF_UNCHECKED, 30003, "Schedule On Hold");
                AllOnHold = TRUE;
                return 0;
            }

            return 0;
        }

        if(wParam==40001) //- About (Dialog Menu Command)
        {
            NetLogo(JobManagerDialog_hWnd);
            return 0;
        }

        if(wParam==50001) //- ReCalculate (Dialog Menu Command)
        {
            CalculateSchedules();
            return 0;
        }

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- About (SysMenu Command)
        {
            NetLogo(JobManagerDialog_hWnd);
            return 0;
        }

        if(LOWORD(wParam) == 1001) //- Version (SysMenu Command)
        {
            char VersionText[128];
            sprintf(VersionText, "%s, Version %s", TitleCaption, FileVersion);
            MessageBox(JobManagerDialog_hWnd, VersionText, "Application Version", MB_TASKMODAL);
            return 0;
        }

        if(LOWORD(wParam) == 1002) //- www.NetWorkDLS.com (SysMenu Command)
        {
            ShellExecute(0,"Open", "Http://www.NetWorkDLS.com", NULL, NULL, SW_SHOWNORMAL);
            return 0;
        }

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_CLOSE)  // Received Close Message
    {
        EndDialog(JobManagerDialog_hWnd,0);
        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_DESTROY) // Received Destroy Message
    {
//        PostQuitMessage(0);
        return 0;
    }

    //--------------------------------------------------------------------------

    return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

